Require Import connectives.
Require Import leibniz.
Require Import logic.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Parameter match_nat_type : forall (return_:Type), return_ -> (nat -> return_) -> nat -> return_.
Axiom axiom_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n).
Definition eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Definition sym_eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (case_S n) (match_nat_type (return_type) case_O case_S (S n)) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Definition pred : nat -> nat := fun (n:nat) => match_nat_type (nat) O (fun (p:nat) => p) n.
Parameter le : nat -> nat -> Prop.
Axiom match_le_prop : forall (n:nat), forall (return_:(nat -> Prop)), (return_ n) -> (forall (m:nat), return_ (S m)) -> forall (m:nat), (le n m) -> return_ m.
Definition lt : nat -> nat -> Prop := fun (n:nat) => fun (m:nat) => le (S n) m.
Definition pred_Sn : forall (n:nat), logic.eq (nat) n (pred (S n)) := fun (n:nat) => ((((((sym_eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (n)) (fun (y:nat) => logic.eq (nat) n y)) (((logic.refl) (nat)) (n)).
Definition S_pred : forall (n:nat), (lt O n) -> logic.eq (nat) (S (pred n)) n := fun (n:nat) => fun (posn:lt O n) => (((((((match_le_prop) (S O)) (fun (__:nat) => logic.eq (nat) (S (pred __)) __)) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (nat) (S __) (S O))) (((logic.refl) (nat)) (S O))) (pred (S O))) ((pred_Sn) (O)))) (fun (m:nat) => ((((((logic.rewrite_l) (nat)) (m)) (fun (__:nat) => logic.eq (nat) (S __) (S m))) (((logic.refl) (nat)) (S m))) (pred (S m))) ((pred_Sn) (m)))) (n)) (posn)).
